/**
  *  \file int/if/richif.h
  */
#ifndef PCC_V2_INT_IF_RICHIF_H
#define PCC_V2_INT_IF_RICHIF_H

#include "ui/richtext.h"
#include "cpluslib/smartptr.h"
#include "int/value.h"

class IntArgBlock;

class IntRichTextValue : public IntValue {
 public:
    IntRichTextValue(Ptr<RichText> value);
    ~IntRichTextValue();

    // IntValue:
    virtual string_t toString(bool readable);
    virtual void store(IntTagNode& sv, Stream& aux);
    virtual IntValue* clone();

    // IntRichTextValue:
    Ptr<RichText> get();

 private:
    Ptr<RichText> value;
};

bool checkRichArg(Ptr<RichText>& out, IntValue* value);

IntValue* IFRAdd(IntArgBlock& args);
IntValue* IFRMid(IntArgBlock& args);
IntValue* IFRString(IntArgBlock& args);
IntValue* IFRLen(IntArgBlock& args);
IntValue* IFRStyle(IntArgBlock& args);
IntValue* IFRLink(IntArgBlock& args);
IntValue* IFRXml(IntArgBlock& args);

#endif
